#!/usr/bin/env node
import c from "prompts";
import { join as x, basename as V } from "node:path";
import { existsSync as o, readFileSync as P, mkdirSync as u, writeFileSync as s, appendFileSync as d, rmSync as g, statSync as T, readdirSync as $ } from "node:fs";
import m from "chalk";
import v from "lodash.upperfirst";
import S from "lodash.camelcase";
import A from "lodash.kebabcase";
import D from "lodash.template";
import _ from "lodash.get";
import b from "lodash.lowerfirst";
import R from "json5";
import { resolveTemplate as N } from "./template.mjs";
import { rootPath as E, configPath as k } from "./path.config.mjs";
const j = () => {
  let r;
  const n = x(E, k);
  if (o(n)) {
    const l = P(n, "utf-8");
    r = R.parse(l);
  }
  if (!r)
    throw new Error("配置文件不存在");
  return r;
}, I = async (r) => {
  const n = r?.series || (await c({
    type: "text",
    name: "series",
    message: "请输入组件系列前缀",
    validate: (l) => l ? !0 : "组件系列前缀不能为空"
  })).series;
  if (!n)
    throw new Error("组件系列前缀不能为空");
  return n;
}, L = async (r) => {
  const n = r?.src || (await c({
    type: "text",
    name: "src",
    message: "请输入组件源码路径",
    initial: "src",
    validate: (l) => l ? !0 : "组件源码路径不能为空"
  })).src;
  if (!n)
    throw new Error("组件源码路径不能为空");
  return n;
}, q = ({
  src: r,
  entryAbsoluteSrc: n,
  entryTemplate: l
}) => {
  const a = x(E, r), y = T(a);
  let e = "";
  if (o(n) && (e = P(n, "utf-8") || ""), !e)
    throw new Error("没有可以删除的文件");
  if (y.isDirectory()) {
    const p = $(a), t = D(l), h = p.map((F) => {
      const f = x(a, F);
      return T(f).isDirectory() ? V(f) : "";
    }).filter((F) => {
      if (!F)
        return !1;
      const f = C({ name: F }), w = t({
        ...f,
        src: r,
        nameLowerFirst: b(f.name)
      });
      return e.includes(w);
    });
    if (h.length === 0)
      throw new Error("组件列表为空");
    return h;
  } else
    throw new Error("组件源码路径不是目录");
}, C = ({
  name: r,
  series: n
}) => {
  const l = v(S(r)), a = n ? v(S(n)) : "", y = n ? `${a}${l}` : "", e = n ? A(y) : "", p = A(r);
  return {
    series: a,
    name: l,
    full: y,
    cls: e,
    dir: p
  };
}, z = async ({
  argv: r,
  configInfo: n
}) => {
  const l = await I(n), a = r.name || (await c({
    type: "text",
    name: "name",
    message: "请输入组件名称",
    validate: (t) => t ? !0 : "组件名称不能为空"
  })).name;
  if (!a)
    throw new Error("组件名称不能为空");
  const y = C({
    name: a,
    series: l
  });
  console.log(y);
  const e = N(
    n,
    {
      ...y,
      rootPath: E
    },
    [
      "component.dir",
      "component.templateFilePath",
      "component.fileName",
      "component.entryTemplate",
      "component.entryPath",
      "type.dir",
      "type.templateFilePath",
      "type.fileName",
      "type.entryTemplate",
      "type.entryPath",
      "style.dir",
      "style.templateFilePath",
      "style.fileName",
      "style.varTemplate",
      "style.varPath",
      "style.entryTemplate",
      "style.entryPath",
      "example.dir",
      "example.templateFilePath",
      "example.fileName",
      "example.entryTemplate",
      "example.entryPath"
    ]
  );
  console.log(e);
  const { useTypeDir: p } = e;
  if (o(e.componentFilePath))
    throw new Error("组件已存在");
  if (p && o(e.typeFilePath))
    throw new Error("类型已存在");
  if (o(e.styleFilePath))
    throw new Error("样式已存在");
  if (o(e.exampleFilePath))
    throw new Error("示例已存在");
  u(e.componentDirPath, { recursive: !0 }), s(e.componentFilePath, e.componentFileContent), p && (u(e.typeDirPath, { recursive: !0 }), s(e.typeFilePath, e.typeFileContent)), u(e.styleDirPath, { recursive: !0 }), s(e.styleFilePath, e.styleFileContent), u(e.exampleDirPath, { recursive: !0 }), s(e.exampleFilePath, e.exampleFileContent), o(e.componentEntryFilePath) || s(e.componentEntryFilePath, ""), d(
    e.componentEntryFilePath,
    e.componentEntryFileAddContent
  ), p && (o(e.typeEntryFilePath) || s(e.typeEntryFilePath, ""), d(e.typeEntryFilePath, e.typeEntryFileAddContent)), o(e.styleEntryFilePath) || s(e.styleEntryFilePath, ""), d(e.styleEntryFilePath, e.styleEntryFileAddContent), o(e.styleVarFilePath) || s(e.styleVarFilePath, ""), d(e.styleVarFilePath, e.styleVarFileAddContent), o(e.exampleEntryFilePath) || s(e.exampleEntryFilePath, ""), d(e.exampleEntryFilePath, e.exampleEntryFileAddContent), console.log(m.green("创建成功"));
}, B = async ({
  configInfo: r,
  src: n
}) => {
  const l = _(r, "component.entryPath"), a = D(l)({
    src: n
  }), y = q({
    src: n,
    entryAbsoluteSrc: x(E, a),
    entryTemplate: r.component.entryTemplate
  }).map((i) => ({ title: i, value: i })), { name: e } = await c({
    type: "select",
    name: "name",
    message: "请选择要删除的组件",
    choices: y
  });
  if (console.log("name:", e), !e)
    throw new Error("组件名称不能为空");
  const p = C({
    name: e
  });
  console.log(p);
  const t = N(
    r,
    {
      ...p,
      rootPath: E
    },
    [
      "component.dir",
      "component.templateFilePath",
      "component.fileName",
      "component.entryTemplate",
      "component.entryPath",
      "type.dir",
      "type.templateFilePath",
      "type.fileName",
      "type.entryTemplate",
      "type.entryPath",
      "style.dir",
      "style.templateFilePath",
      "style.fileName",
      "style.varTemplate",
      "style.varPath",
      "style.entryTemplate",
      "style.entryPath",
      "example.dir",
      "example.templateFilePath",
      "example.fileName",
      "example.entryTemplate",
      "example.entryPath"
    ]
  );
  console.log(t);
  const { useTypeDir: h } = t;
  o(t.componentFilePath) || console.log(m.red("组件不存在")), h && (o(t.typeFilePath) || console.log(m.red("类型不存在"))), o(t.styleFilePath) || console.log(m.red("样式不存在")), o(t.exampleFilePath) || console.log(m.red("示例不存在"));
  const { delComponent: F } = await c({
    type: "confirm",
    name: "delComponent",
    message: `确认删除${t.componentDirPath}吗`
  });
  if (!F)
    throw new Error("取消删除");
  if (h) {
    const { delType: i } = await c({
      type: "confirm",
      name: "delType",
      message: `确认删除${t.typeFilePath}吗`
    });
    if (!i)
      throw new Error("取消删除");
  }
  const { delStyle: f } = await c({
    type: "confirm",
    name: "delStyle",
    message: `确认删除${t.styleFilePath}吗`
  });
  if (!f)
    throw new Error("取消删除");
  const { delExample: w } = await c({
    type: "confirm",
    name: "delExample",
    message: `确认删除${t.exampleDirPath}吗`
  });
  if (!w)
    throw new Error("取消删除");
  if (g(t.componentDirPath, { recursive: !0, force: !0 }), h && g(t.typeFilePath), g(t.styleFilePath), g(t.exampleDirPath, { recursive: !0, force: !0 }), !o(t.componentEntryFilePath))
    console.log(m.red("组件入口不存在"));
  else {
    const i = P(t.componentEntryFilePath, "utf-8");
    s(
      t.componentEntryFilePath,
      i.replace(t.componentEntryFileAddContent, "")
    );
  }
  if (h)
    if (!o(t.typeEntryFilePath))
      console.log(m.red("类型入口不存在"));
    else {
      const i = P(t.typeEntryFilePath, "utf-8");
      s(
        t.typeEntryFilePath,
        i.replace(t.typeEntryFileAddContent, "")
      );
    }
  if (!o(t.styleEntryFilePath))
    console.log(m.red("样式入口不存在"));
  else {
    const i = P(t.styleEntryFilePath, "utf-8");
    s(
      t.styleEntryFilePath,
      i.replace(t.styleEntryFileAddContent, "")
    );
  }
  if (!o(t.styleVarFilePath))
    console.log(m.red("样式变量不存在"));
  else {
    const i = P(t.styleVarFilePath, "utf-8");
    s(
      t.styleVarFilePath,
      i.replace(t.styleVarFileAddContent, "")
    );
  }
  if (!o(t.exampleEntryFilePath))
    console.log(m.red("示例入口不存在"));
  else {
    const i = P(t.exampleEntryFilePath, "utf-8");
    s(
      t.exampleEntryFilePath,
      i.replace(t.exampleEntryFileAddContent, "")
    );
  }
  console.log(m.green("删除成功"));
}, te = async (r, n) => {
  const l = j(), a = await L(l);
  if (r === "add")
    await z({ argv: n, configInfo: l, src: a });
  else if (r === "remove")
    await B({ argv: n, configInfo: l, src: a });
  else
    throw new Error(`未知命令${r}`);
};
export {
  z as dealAdd,
  B as dealRemove,
  C as getAllNameInfo,
  te as handler
};
