export interface Options {
    /**
     * 检查目标系列组件
     * @param name
     * @returns
     */
    checkIsSeries: (name: string) => boolean;
    /**
     * 获取组件名称
     * @param name
     * @returns
     */
    getComponentName: (name: string) => string;
    /**
     * 组件dir
     * @param name
     * @returns
     */
    componentsDir: string;
    /**
     * 获取样式路径
     * @param name
     * @returns
     */
    getStylePath: (options: {
        name: string;
        componentName: string;
        kebabComponentName: string;
    }) => string;
    /**
     * 是否开启调试模式
     */
    debug?: boolean;
}
/**
 * 组件加载解析器
 */
export declare const resolver: ({ checkIsSeries, getComponentName, getStylePath, componentsDir, debug, }: Options) => {
    type: "component";
    resolve: (name: string) => {
        name: string;
        from: string;
        sideEffects: string;
    } | undefined;
};
